---
title: "Install a platform licence"
description: "Installs an offline-verified licence and applies its plan tier. Requires an idempotency key. The submitted token is never returned.\n\n### Quire permissions\n\nRequired capability: `platform/licence_manage`.\n\nCredential scopes: `tenants:write`.\n\nThe acting subject must also be allowed to perform this action in the organisation."
image: "https://docs.quirelms.com/og.png"
---

> Documentation Index
> Fetch the complete documentation index at: https://docs.quirelms.com/llms.txt
> Use this file to discover all available pages before exploring further.

Path: Quire API › tenants

`PUT /platform/licence`

Installs an offline-verified licence and applies its plan tier. Requires an idempotency key. The submitted token is never returned.

\### Quire permissions

Required capability: `platform/licence_manage`.

Credential scopes: `tenants:write`.

The acting subject must also be allowed to perform this action in the organisation.

## Authentication

Requires one of the following:

- `apiKey`, http, header `Authorization`, scopes: `tenants:write`
- `oauth2`, oauth2, scopes: `tenants:write`

## Header parameters

- `installPlatformLicence.header.Idempotency-Key` (string, required) — A caller-chosen key making this request safe to retry. A replay of a completed request returns the recorded response with `Idempotency-Replayed: true`. Reusing a key for a different request is refused.
  - maxLength 255
- `installPlatformLicence.header.Quire-Version` (string, optional) — The dated API revision to serve this request at. Omitted, the request is served at the revision the credential was issued against. The response echoes the revision actually applied.
  - format `date`

## Request body

_Required._

- `installPlatformLicence.token` (string, required)
  - minLength 1; maxLength 16384

## Example request

```json
{
  "token": "string"
}
```

## Code samples

### cURL

```curl
curl --request PUT \
  --url https://your-organisation.quirelms.com/api/v1/platform/licence \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'Idempotency-Key: string' \
  --data '
{
  "token": "string"
}
'
```

### TypeScript

```typescript
const url = 'https://your-organisation.quirelms.com/api/v1/platform/licence';
const options = {
  method: 'PUT',
  headers: {
    'Content-Type': 'application/json',
    'Idempotency-Key': 'string',
    Authorization: 'Bearer <token>'
  },
  body: JSON.stringify({token: 'string'})
};

fetch(url, options)
  .then(res => res.json())
  .then(json => console.log(json))
  .catch(err => console.error(err));
```

### Python

```python
import requests

url = "https://your-organisation.quirelms.com/api/v1/platform/licence"

payload = { "token": "string" }
headers = {
    "Content-Type": "application/json",
    "Idempotency-Key": "string",
    "Authorization": "Bearer <token>"
}

response = requests.put(url, json=payload, headers=headers)

print(response.text)
```

## Responses

### 200

Success.

#### Example

```json
{
  "installed": true,
  "licensee": "string",
  "tier": "string",
  "kid": "string",
  "caps": {
    "property1": 0,
    "property2": 0
  },
  "features": [
    "string"
  ],
  "not_before": "2019-08-24T14:15:22Z",
  "expires_at": "2019-08-24T14:15:22Z",
  "grace_ends_at": "2019-08-24T14:15:22Z",
  "state": "none",
  "invalid_reason": "malformed",
  "clock_warning": true,
  "keys": [
    "string"
  ],
  "revoked": [
    {
      "licence_id": "string",
      "reason": "string",
      "revoked_at": "2019-08-24T14:15:22Z"
    }
  ]
}
```

- `installPlatformLicence.response.200.installed` (boolean, required)
- `installPlatformLicence.response.200.licensee` (string | null, required)
- `installPlatformLicence.response.200.tier` (string | null, required)
- `installPlatformLicence.response.200.kid` (string | null, required)
- `installPlatformLicence.response.200.caps` (map<number>, required)
- `installPlatformLicence.response.200.features` (array<string>, required)
- `installPlatformLicence.response.200.not_before` (any of, required)
  - any of: `string`, `null`
- `installPlatformLicence.response.200.expires_at` (any of, required)
  - any of: `string`, `null`
- `installPlatformLicence.response.200.grace_ends_at` (any of, required)
  - any of: `string`, `null`
- `installPlatformLicence.response.200.state` (string, required)
  - one of `"none"`, `"valid"`, `"expiring"`, `"grace"`, `"lapsed"`, `"invalid"`
- `installPlatformLicence.response.200.invalid_reason` (any of, required)
  - any of: `string`, `null`
- `installPlatformLicence.response.200.clock_warning` (boolean, required)
- `installPlatformLicence.response.200.keys` (array<string>, required)
- `installPlatformLicence.response.200.revoked` (array<object>, required)
  - `installPlatformLicence.response.200.revoked.licence_id` (string, required)
  - `installPlatformLicence.response.200.revoked.reason` (string, required)
  - `installPlatformLicence.response.200.revoked.revoked_at` (string, required)
    - format `date-time`; pattern `^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d:[0-5]\d(?:\.\d+)?(?:Z))$`

### 401

The credential is missing, malformed, expired or revoked.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `installPlatformLicence.response.401.type` (string, required)
  - format `uri`
- `installPlatformLicence.response.401.title` (string, required)
- `installPlatformLicence.response.401.status` (integer, required)
- `installPlatformLicence.response.401.code` (string, required)
- `installPlatformLicence.response.401.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `installPlatformLicence.response.401.detail` (string, required)
- `installPlatformLicence.response.401.request_id` (string, required)
- `installPlatformLicence.response.401.docs_url` (string, required)
  - format `uri`
- `installPlatformLicence.response.401.errors` (array<object>, optional)
  - `installPlatformLicence.response.401.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `installPlatformLicence.response.401.errors.code` (string, required)
  - `installPlatformLicence.response.401.errors.detail` (string, required)
- `installPlatformLicence.response.401.retry_after` (integer | null, optional)

### 403

The credential lacks the scope this operation requires, or the acting subject lacks the capability.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `installPlatformLicence.response.403.type` (string, required)
  - format `uri`
- `installPlatformLicence.response.403.title` (string, required)
- `installPlatformLicence.response.403.status` (integer, required)
- `installPlatformLicence.response.403.code` (string, required)
- `installPlatformLicence.response.403.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `installPlatformLicence.response.403.detail` (string, required)
- `installPlatformLicence.response.403.request_id` (string, required)
- `installPlatformLicence.response.403.docs_url` (string, required)
  - format `uri`
- `installPlatformLicence.response.403.errors` (array<object>, optional)
  - `installPlatformLicence.response.403.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `installPlatformLicence.response.403.errors.code` (string, required)
  - `installPlatformLicence.response.403.errors.detail` (string, required)
- `installPlatformLicence.response.403.retry_after` (integer | null, optional)

### 409

The request conflicts with the current state, with a previous use of the same idempotency key, or with a concurrent write.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `installPlatformLicence.response.409.type` (string, required)
  - format `uri`
- `installPlatformLicence.response.409.title` (string, required)
- `installPlatformLicence.response.409.status` (integer, required)
- `installPlatformLicence.response.409.code` (string, required)
- `installPlatformLicence.response.409.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `installPlatformLicence.response.409.detail` (string, required)
- `installPlatformLicence.response.409.request_id` (string, required)
- `installPlatformLicence.response.409.docs_url` (string, required)
  - format `uri`
- `installPlatformLicence.response.409.errors` (array<object>, optional)
  - `installPlatformLicence.response.409.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `installPlatformLicence.response.409.errors.code` (string, required)
  - `installPlatformLicence.response.409.errors.detail` (string, required)
- `installPlatformLicence.response.409.retry_after` (integer | null, optional)

### 422

The request was understood and its content is not valid. `errors` names each field.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `installPlatformLicence.response.422.type` (string, required)
  - format `uri`
- `installPlatformLicence.response.422.title` (string, required)
- `installPlatformLicence.response.422.status` (integer, required)
- `installPlatformLicence.response.422.code` (string, required)
- `installPlatformLicence.response.422.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `installPlatformLicence.response.422.detail` (string, required)
- `installPlatformLicence.response.422.request_id` (string, required)
- `installPlatformLicence.response.422.docs_url` (string, required)
  - format `uri`
- `installPlatformLicence.response.422.errors` (array<object>, optional)
  - `installPlatformLicence.response.422.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `installPlatformLicence.response.422.errors.code` (string, required)
  - `installPlatformLicence.response.422.errors.detail` (string, required)
- `installPlatformLicence.response.422.retry_after` (integer | null, optional)

### 429

A rate limit or a concurrency cap was reached. `Retry-After` says when to try again.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `installPlatformLicence.response.429.type` (string, required)
  - format `uri`
- `installPlatformLicence.response.429.title` (string, required)
- `installPlatformLicence.response.429.status` (integer, required)
- `installPlatformLicence.response.429.code` (string, required)
- `installPlatformLicence.response.429.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `installPlatformLicence.response.429.detail` (string, required)
- `installPlatformLicence.response.429.request_id` (string, required)
- `installPlatformLicence.response.429.docs_url` (string, required)
  - format `uri`
- `installPlatformLicence.response.429.errors` (array<object>, optional)
  - `installPlatformLicence.response.429.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `installPlatformLicence.response.429.errors.code` (string, required)
  - `installPlatformLicence.response.429.errors.detail` (string, required)
- `installPlatformLicence.response.429.retry_after` (integer | null, optional)

### 500

Something failed at our end. Quote `request_id` when reporting it.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `installPlatformLicence.response.500.type` (string, required)
  - format `uri`
- `installPlatformLicence.response.500.title` (string, required)
- `installPlatformLicence.response.500.status` (integer, required)
- `installPlatformLicence.response.500.code` (string, required)
- `installPlatformLicence.response.500.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `installPlatformLicence.response.500.detail` (string, required)
- `installPlatformLicence.response.500.request_id` (string, required)
- `installPlatformLicence.response.500.docs_url` (string, required)
  - format `uri`
- `installPlatformLicence.response.500.errors` (array<object>, optional)
  - `installPlatformLicence.response.500.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `installPlatformLicence.response.500.errors.code` (string, required)
  - `installPlatformLicence.response.500.errors.detail` (string, required)
- `installPlatformLicence.response.500.retry_after` (integer | null, optional)


Source: https://docs.quirelms.com/api/tenants/installPlatformLicence/index.md
